"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DOMListener = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable flowtype/no-weak-types */
function addListener(target, type, listener, options) {
  target.addEventListener(type, listener, options);
}

function removeListener(target, type, listener, options) {
  target.removeEventListener(type, listener, options);
}
/* eslint-enable flowtype/no-weak-types */


var DOMListener =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DOMListener, _React$Component);

  function DOMListener() {
    var _getPrototypeOf2;

    var _temp, _this;

    _classCallCheck(this, DOMListener);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(DOMListener)).call.apply(_getPrototypeOf2, [this].concat(args))), _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      options: false
    }), _temp));
  }

  _createClass(DOMListener, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          listener = _this$props.listener,
          target = _this$props.target,
          type = _this$props.type;
      addListener(target, type, listener, this.state.options);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this$props2 = this.props,
          capture = _this$props2.capture,
          listener = _this$props2.listener,
          once = _this$props2.once,
          passive = _this$props2.passive,
          target = _this$props2.target,
          type = _this$props2.type;
      var options = this.state.options;

      if (capture !== prevProps.capture || listener !== prevProps.listener || once !== prevProps.once || passive !== prevProps.passive || target !== prevProps.target || type !== prevProps.type) {
        removeListener(prevProps.target, prevProps.type, prevProps.listener, prevState.options);
        addListener(target, type, listener, options);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props3 = this.props,
          listener = _this$props3.listener,
          target = _this$props3.target,
          type = _this$props3.type;
      removeListener(target, type, listener, this.state.options);
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var capture = nextProps.capture,
          once = nextProps.once,
          passive = nextProps.passive;

      if (once !== undefined || passive !== undefined) {
        return {
          options: {
            capture,
            once,
            passive
          }
        };
      }

      return {
        options: !!capture
      };
    }
  }]);

  return DOMListener;
}(_react.default.Component);

exports.DOMListener = DOMListener;